# HG changeset patch
# User Markus Mützel <markus.muetzel@gmx.de>
# Date 1596274701 -7200
#      Sat Aug 01 11:38:21 2020 +0200
# Node ID 2d7529795d7b1b0cb723a516d7a2844eac59fc6c
# Parent  9f9ed6a325bdc18c104376f79f635db50ec22754
Move release-octave to latest SUNDIALS IDA.

* src/release-octave.mk: Depend on sundials-ida.
* src/sundials-27-ida.mk, src/sundials-27-ida-1.patch: Remove files.
* dist-files.mk: Delete removed files from list.
* index.html: Remove package from index.

diff -r 9f9ed6a325bd -r 2d7529795d7b dist-files.mk
--- a/dist-files.mk	Fri Jul 31 14:59:35 2020 +0200
+++ b/dist-files.mk	Sat Aug 01 11:38:21 2020 +0200
@@ -692,8 +692,6 @@
   suitesparse-1-fixes.patch \
   suitesparse-2-metis.patch \
   suitesparse.mk \
-  sundials-27-ida-1.patch \
-  sundials-27-ida.mk \
   sundials-ida.mk \
   t4k_common.mk \
   taglib-1-static.patch \
diff -r 9f9ed6a325bd -r 2d7529795d7b index.html
--- a/index.html	Fri Jul 31 14:59:35 2020 +0200
+++ b/index.html	Sat Aug 01 11:38:21 2020 +0200
@@ -2690,10 +2690,6 @@
         <td class="website"><a href="http://www.cise.ufl.edu/research/sparse/SuiteSparse/">SuiteSparse</a></td>
     </tr>
     <tr>
-        <td class="package">sundials-27-ida</td>
-        <td class="website"><a href="http://computation.llnl.gov/projects/sundials/">Sundials IDA v2.7.0</a> (can be removed once Octave 5 is phased out)</td>
-    </tr>
-    <tr>
         <td class="package">sundials-ida</td>
         <td class="website"><a href="http://computation.llnl.gov/projects/sundials/">Sundials IDA</a></td>
     </tr>
diff -r 9f9ed6a325bd -r 2d7529795d7b src/release-octave.mk
--- a/src/release-octave.mk	Fri Jul 31 14:59:35 2020 +0200
+++ b/src/release-octave.mk	Sat Aug 01 11:38:21 2020 +0200
@@ -42,7 +42,7 @@
 ifeq ($(USE_SYSTEM_FONTCONFIG),no)
   $(PKG)_FONTCONFIG := fontconfig
 endif
-$(PKG)_DEPS     := blas arpack curl epstool fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack libsndfile pcre portaudio pstoedit qhull qrupdate qscintilla readline sundials-27-ida suitesparse texinfo zlib
+$(PKG)_DEPS     := blas arpack curl epstool fftw fltk $($(PKG)_FONTCONFIG) ghostscript gl2ps glpk gnuplot graphicsmagick hdf5 lapack libsndfile pcre portaudio pstoedit qhull qrupdate qscintilla readline sundials-ida suitesparse texinfo zlib
 
 ifeq ($(ENABLE_QT5),yes)
     $(PKG)_DEPS += qt5
diff -r 9f9ed6a325bd -r 2d7529795d7b src/sundials-27-ida-1.patch
--- a/src/sundials-27-ida-1.patch	Fri Jul 31 14:59:35 2020 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,20 +0,0 @@
-Add missing dependency on KLU when building IDA shared library.
-
-Based on a patch in the Debian sundials package by Dima Kogan.
-
-https://anonscm.debian.org/cgit/debian-science/packages/sundials.git/tree/debian/patches/0001-Added-missing-linkages-
-
-diff --git a/src/ida/CMakeLists.txt b/src/ida/CMakeLists.txt
---- a/src/ida/CMakeLists.txt
-+++ b/src/ida/CMakeLists.txt
-@@ -135,6 +135,10 @@ IF(BUILD_SHARED_LIBS)
-   ADD_LIBRARY(sundials_ida_shared SHARED
-     ${ida_SOURCES}  ${ida_BL_SOURCES} ${shared_SOURCES})
- 
-+  IF(KLU_FOUND)
-+    TARGET_LINK_LIBRARIES(sundials_ida_shared -lklu)
-+  ENDIF(KLU_FOUND)
-+
-   # Set the library name and make sure it is not deleted
-   SET_TARGET_PROPERTIES(sundials_ida_shared
-     PROPERTIES OUTPUT_NAME sundials_ida CLEAN_DIRECT_OUTPUT 1)
diff -r 9f9ed6a325bd -r 2d7529795d7b src/sundials-27-ida.mk
--- a/src/sundials-27-ida.mk	Fri Jul 31 14:59:35 2020 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,46 +0,0 @@
-# This file is part of MXE.
-# See index.html for further information.
-# This file can be removed once Octave 5 is phased out.
-
-PKG             := sundials-27-ida
-$(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 2.7.0
-$(PKG)_CHECKSUM := 3559c375ce9f875542e4a39978908f91792e6d57
-$(PKG)_SUBDIR   := sundials-$($(PKG)_VERSION)
-$(PKG)_FILE     := sundials-$($(PKG)_VERSION).tar.gz
-$(PKG)_URL      := https://computation.llnl.gov/projects/sundials/download/$($(PKG)_FILE)
-$(PKG)_DEPS     := lapack suitesparse
-ifeq ($(USE_SYSTEM_GCC),no)
-  $(PKG)_DEPS += libgomp
-endif
-
-define $(PKG)_UPDATE
-    echo 'Warning: Updates are temporarily disabled for package $(PKG).' >&2;
-    echo $($(PKG)_VERSION)
-endef
-
-define $(PKG)_BUILD
-    mkdir '$(1).build'
-    cd '$(1).build' && cmake \
-        -DEXAMPLES_ENABLE=OFF \
-        -DKLU_ENABLE=ON \
-        -DKLU_INCLUDE_DIR=$(HOST_INCDIR)/suitesparse \
-        -DKLU_LIBRARY_DIR=$(HOST_LIBDIR) \
-        -DSUITESPARSECONFIG_LIBRARY=$(HOST_LIBDIR)/libsuitesparseconfig.dll.a \
-        -DCMAKE_TOOLCHAIN_FILE='$(CMAKE_TOOLCHAIN_FILE)' \
-	-DBUILD_ARKODE=OFF \
-	-DBUILD_CVODE=OFF \
-	-DBUILD_CVODES=OFF \
-	-DBUILD_IDA=ON \
-	-DBUILD_IDAS=OFF \
-	-DBUILD_KINSOL=OFF \
-	-DBUILD_CPODES=OFF \
-        '$(1)'
-    $(MAKE) -C '$(1).build' -j '$(JOBS)' install DESTDIR='$(3)' VERBOSE=1
-
-    if [ $(MXE_SYSTEM) = mingw ]; then \
-        echo "Install dlls"; \
-        $(INSTALL) -d '$(3)$(HOST_BINDIR)'; \
-        mv '$(3)$(HOST_LIBDIR)/'libsundials*.dll '$(3)$(HOST_BINDIR)/'; \
-    fi
-endef