# HG changeset patch
# User Kai T. Ohlhus <k.ohlhus@gmail.com>
# Date 1599037974 -32400
#      Wed Sep 02 18:12:54 2020 +0900
# Node ID 0d19d897c9b01e89669fadef9f4b62dd4fee796e
# Parent  f55bdd2e264b9a81bc9ca1f4365b814087d3247e
Remove bootstrap, configure.ac, etc.

diff -r f55bdd2e264b -r 0d19d897c9b0 src/bootstrap
--- a/src/bootstrap	Mon Aug 24 22:39:35 2020 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,7 +0,0 @@
-#! /bin/sh
-
-aclocal
-
-autoconf
-
-autoheader -f
diff -r f55bdd2e264b -r 0d19d897c9b0 src/cell2csv.cc
--- a/src/cell2csv.cc	Mon Aug 24 22:39:35 2020 +0200
+++ b/src/cell2csv.cc	Wed Sep 02 18:12:54 2020 +0900
@@ -55,7 +55,7 @@
 #include <octave/oct.h>
 #include <octave/Cell.h>
 
-#include "config.h"
+#include "octave_4_2_compatibility.h"
 
 DEFUN_DLD (cell2csv, args, nargout,
           "-*- texinfo -*-\n"
@@ -135,7 +135,7 @@ DEFUN_DLD (cell2csv, args, nargout,
         word += str;
       }
 
-      else if (!c(i, j).OV_ISEMPTY ()) {
+      else if (!c(i, j).isempty ()) {
         /* Output NaN value */
         warning ("cell2csv: empty cell or not a real or a string value - converted to 'NaN'\n");
         word += "NaN";
diff -r f55bdd2e264b -r 0d19d897c9b0 src/configure.ac
--- a/src/configure.ac	Mon Aug 24 22:39:35 2020 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,110 +0,0 @@
-#                                               -*- Autoconf -*-
-# Process this file with autoconf to produce a configure script.
-#
-### Copyright (C) 2015-2020 Olaf Till <i7tiol@t-online.de>
-###
-### This program is free software; you can redistribute it and/or
-### modify it under the terms of the GNU General Public License as
-### published by the Free Software Foundation; either version 3 of the
-### License, or (at your option) any later version.
-###
-### This program is distributed in the hope that it will be useful,
-### but WITHOUT ANY WARRANTY; without even the implied warranty of
-### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
-### General Public License for more details.
-###
-### You should have received a copy of the GNU General Public License
-### along with this program; if not, see
-### <http://www.gnu.org/licenses/>.
-
-AC_PREREQ([2.67])
-AC_INIT([io], [2.6.1], [Philip Nienhuis <prnienhuis@users.sf.net>])
-AC_CONFIG_SRCDIR([csv2cell.cc])
-AC_CONFIG_HEADERS([config.h])
-
-# Avoid warnings for redefining AH-generated preprocessor symbols of
-# Octave.
-AH_TOP([#include "undef-ah-octave.h"])
-
-AC_CONFIG_MACRO_DIRS([m4])
-
-# Checks for programs.
-AC_CHECK_PROG(MKOCTFILE, mkoctfile, mkoctfile)
-if test -z "$MKOCTFILE"; then
-AC_MSG_ERROR([mkoctfile not found], 1);
-fi
-AC_CHECK_PROG(OCTAVE_CONFIG, octave-config, octave-config)
-if test -z "$OCTAVE_CONFIG"; then
-AC_MSG_ERROR([octave-config not found], 1);
-fi
-
-# The same value of CXX as Octave was compiled with is supposed to be used.
-CXX=${CXX:-`${MKOCTFILE} -p CXX`}
-AC_PROG_CXX
-  
-AC_PROG_CXXCPP
-
-# Checks for libraries.
-
-# Checks for typedefs, structures, and compiler characteristics.
-
-# Checks for library functions.
-
-# Start of checks for Octave features, preparations for checks.
-OCTLIBDIR=${OCTLIBDIR:-`$OCTAVE_CONFIG -p OCTLIBDIR`}
-## We need Octaves include path both with and without '/octave'
-## appended. The path without '/octave' is needed to selectively test
-## for Octave headers, like octave/....h. The path with '/octave' is
-## needed since some Octave headers contain include directives for
-## other Octave headers with <> instead of "".
-OCTINCLUDEDIR=${OCTINCLUDEDIR:-`$MKOCTFILE -p INCFLAGS`}
-AC_LANG_PUSH([C++])
-TCXXFLAGS=$CXXFLAGS
-TLDFLAGS=$LDFLAGS
-TLIBS=$LIBS
-TCPPFLAGS=$CPPFLAGS
-LDFLAGS="-L$OCTLIBDIR $LDFLAGS"
-LIBS="-loctinterp $LIBS"
-# CXXFLAGS=
-CPPFLAGS="$OCTINCLUDEDIR $CPPFLAGS"
-
-## Simple symbol alternatives of different Octave versions.
-OF_OCTAVE_LIST_ALT_SYMS([
-[dnl
-  [is_numeric_type],
-  [isnumeric],
-  [[octave_value ().isnumeric ();]],
-  [OV_ISNUMERIC],
-  [],
-  []
-],
-
-[dnl
-  [is_cell],
-  [iscell],
-  [[octave_value ().iscell ();]],
-  [OV_ISCELL],
-  [],
-  []
-],
-
-[dnl
-  [is_empty],
-  [isempty],
-  [[octave_value ().isempty ();]],
-  [OV_ISEMPTY],
-  [],
-  []
-]
-
-],
-   [oct-alt-includes.h])
-
-LIBS=$TLIBS
-LDFLAGS=$TLDFLAGS
-CXXFLAGS=$TCXXFLAGS
-CPPFLAGS=$TCPPFLAGS
-AC_LANG_POP([C++])
-# End of checks for Octave features.
-
-AC_OUTPUT
diff -r f55bdd2e264b -r 0d19d897c9b0 src/csv2cell.cc
--- a/src/csv2cell.cc	Mon Aug 24 22:39:35 2020 +0200
+++ b/src/csv2cell.cc	Wed Sep 02 18:12:54 2020 +0900
@@ -188,7 +188,7 @@
 #include <octave/ov.h>
 #include <octave/file-ops.h>
 
-#include "config.h"
+#include "octave_4_2_compatibility.h"
 
 #define MAXSTRINGLENGTH 32768
 
@@ -250,8 +250,8 @@ separators will yield 32769 empty values
   const std::string file = octave::sys::file_ops::tilde_expand (args (0).string_value ());
 
   /* Look if first arg after filename = numeric. If yes => headerlines */
-  long hlines = (nargin > 1 && args(1).OV_ISNUMERIC () ? args(1).long_value() : 0);
-  int arg_sh = (nargin > 1 && args(1).OV_ISNUMERIC () ? 1 : 0);
+  long hlines = (nargin > 1 && args(1).isnumeric () ? args(1).long_value() : 0);
+  int arg_sh = (nargin > 1 && args(1).isnumeric () ? 1 : 0);
 
   bool lr = false;
   int lcol = 1;
diff -r f55bdd2e264b -r 0d19d897c9b0 src/csvexplode.cc
--- a/src/csvexplode.cc	Mon Aug 24 22:39:35 2020 +0200
+++ b/src/csvexplode.cc	Wed Sep 02 18:12:54 2020 +0900
@@ -16,7 +16,7 @@
 #include <octave/oct.h>
 #include <octave/Cell.h>
 
-#include "config.h"
+#include "octave_4_2_compatibility.h"
 
 DEFUN_DLD (csvexplode, args, nargout,
            "-*- texinfo -*-\n"
@@ -38,7 +38,7 @@ DEFUN_DLD (csvexplode, args, nargout,
 
   /* Get arguments */
   if (! args(0).is_string ()) {
-    if (args(0).OV_ISCELL ())
+    if (args(0).iscell ())
       return octave_value (args(0));
     else
       return octave_value (Cell(args(0)));
diff -r f55bdd2e264b -r 0d19d897c9b0 src/m4/octave-forge.m4
--- a/src/m4/octave-forge.m4	Mon Aug 24 22:39:35 2020 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,93 +0,0 @@
-# Copyright (C) 2017-2020 Olaf Till <i7tiol@t-online.de>
-# Modifications to print what is searching for by JohnD
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-# General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, see <http://www.gnu.org/licenses/>.
-
-# arguments of OF_OCTAVE_ALT_SYMS (see also description of
-# OF_OCTAVE_LIST_ALT_SYMS below):
-#
-# $1: symbol version 1
-# $2: symbol version 2
-# $3: test for symbol version 2
-# $4: macro name to access alternative symbols
-# $5: include directives for symbol version 1
-# $6: include directives for symbol version 2
-# (a list of lists of args 1--6 is $1 of OF_OCTAVE_LIST_ALT_SYMS)
-# $7: name of generated include file with alternatives of Octave headers
-# (arg7 is $2 of OF_OCTAVE_LIST_ALT_SYMS)
-AC_DEFUN([OF_OCTAVE_ALT_SYMS], [
-AC_MSG_CHECKING([$1 or $2])
-  AC_COMPILE_IFELSE(
-    [AC_LANG_PROGRAM([[#include <octave/oct.h>]
-                      $6],
-                     [$3])],
-    [AC_DEFINE($4,
-               [[$2]],
-               [macro for alternative Octave symbols])
-     AC_MSG_RESULT([$2])
-     echo '$6' >> $7],
-    [AC_DEFINE($4,
-               [[$1]],
-               [macro for alternative Octave symbols])
-     AC_MSG_RESULT([$1])
-     echo '$5' >> $7]
-)
-])
-
-
-# OF_OCTAVE_LIST_ALT_SYMS is called in the following way:
-#
-# OF_OCTAVE_LIST_ALT_SYMS([
-# [dnl
-#   [old_octave_symbol],
-#   [new_octave_symbol],
-#   [[compilation test]
-#    [for new_octave_symbol]],
-#   [NAME_OF_GENERATED_MACRO____WILL_EXPAND_TO_OLD_OR_NEW_SYMBOL],
-#   [[include directives]
-#    [except #include <octave/oct.h>]
-#    [necessary to compile with old_octave_symbol]],
-#   [[include directives]
-#    [except #include <octave/oct.h>]
-#    [nessary to compile with new_octave_symbol]
-#    [and to compile the test]]
-# ],
-#
-# ... further such lists as the above
-#
-# ],
-#
-# [name-of-header-file-for-alternative-octave-iclude-directives.h])
-#
-#
-# This file should be put into src/m4/, and the line
-#
-# AC_CONFIG_MACRO_DIRS([m4])
-#
-# should be put into src/configure.ac. The package should use
-# autoheader to generate config.h.in (src/bootstrap should contain the
-# lines 'aclocal', 'autoconf', and 'autoheader -f'). Package code
-# should include config.h and use the generated macros to access the
-# alternative symbols of Octave. An example of a call to
-# OF_OCTAVE_LIST_ALT_SYMS in src/configure.ac is available together
-# with this file.
-AC_DEFUN([OF_OCTAVE_LIST_ALT_SYMS], [
-
-echo '/* generated by configure */' > $2
-
-m4_foreach([it], [$1], [m4_apply([OF_OCTAVE_ALT_SYMS], [it, $2])])
-
-AH_BOTTOM([#include "$2"])
-
-])
diff -r f55bdd2e264b -r 0d19d897c9b0 src/octave_4_2_compatibility.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/octave_4_2_compatibility.h	Wed Sep 02 18:12:54 2020 +0900
@@ -0,0 +1,12 @@
+#if ! defined (OCTAVE_4_2_COMPATIBILITY_H_)
+#define OCTAVE_4_2_COMPATIBILITY_H_ 1
+
+#include <octave/version.h>
+
+#if OCTAVE_MAJOR_VERSION == 4 && OCTAVE_MINOR_VERSION < 4
+  #define iscell    is_cell
+  #define isempty   is_empty
+  #define isnumeric is_numeric
+#endif
+
+#endif
diff -r f55bdd2e264b -r 0d19d897c9b0 src/undef-ah-octave.h
--- a/src/undef-ah-octave.h	Mon Aug 24 22:39:35 2020 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,27 +0,0 @@
-/* To be included at the top of config.h (by autoheader). Avoid
-   warnings for redefining AH-generated preprocessor symbols of
-   Octave. */
-
-#ifdef PACKAGE_BUGREPORT
-#undef PACKAGE_BUGREPORT
-#endif
-
-#ifdef PACKAGE_NAME
-#undef PACKAGE_NAME
-#endif
-
-#ifdef PACKAGE_STRING
-#undef PACKAGE_STRING
-#endif
-
-#ifdef PACKAGE_TARNAME
-#undef PACKAGE_TARNAME
-#endif
-
-#ifdef PACKAGE_URL
-#undef PACKAGE_URL
-#endif
-
-#ifdef PACKAGE_VERSION
-#undef PACKAGE_VERSION
-#endif